Index: /bdm/user_info.h
===================================================================
--- /bdm/user_info.h (revision 351)
+++ /bdm/user_info.h (revision 357)
@@ -1,21 +1,14 @@
-#ifndef UIBUILD
-#define UIBUILD
-
-
-#include <sstream>
-#include <iostream>
+#ifndef USER_INFO_H
+#define USER_INFO_H
+
 #include <stdio.h>
 #include <string>
 #include <typeinfo>
 #include <map>
-#include <utility>
-#include <vector>
-#include <iostream>
 
 #include "libconfig/libconfig.h++"
-
-#include <itpp/itbase.h>
-
-#include "stat/libBM.h"
+#include "bdmroot.h"
+#include "itpp/itbase.h"
+
 
 using std::string;
@@ -35,12 +28,12 @@
 
 public:
-	//! attach new RootElement instance to a file (typically with an XML extension)
+	//! create empty object prepared to store Settings
+	UI_File();
+
+	//! creates object and fills it from a file
 	UI_File( const string &file_name );
 
-	//! loads root element from a file
-	void load();
-
-	//! save UserInfo to the file (typically with an XML extension)
-	void save();
+	//! save UserInfo to the file 
+	void save(const string &file_name);
 
 	operator Setting&();
@@ -141,11 +134,7 @@
 	//! and build DOM tree accordingly. Then, it creates a new DOMNode named according class_name
 	//! and connecti it to the passed Setting as a new child node.
-	static const Setting* pointer_to_child_setting( const Setting &element, const int index );
-
-	static const Setting* pointer_to_child_setting( const Setting &element, const string &name );
-
-	static const Setting& reference_to_child_setting( const Setting &element, const int index );
-
-	static const Setting& reference_to_child_setting( const Setting &element, const string &name );
+	static const Setting& to_child_setting( const Setting &element, const int index );
+
+	static const Setting& to_child_setting( const Setting &element, const string &name );
 
 
@@ -153,8 +142,10 @@
 	static void from_setting( mat& matrix, const Setting &element );	
 	//! This methods tries to build a new integer vector
-	static void from_setting( ivec &vec, const Setting &element );
+	static void from_setting( ivec &vector, const Setting &element );
 	// jednak kvuli pretypovani, apak taky proto, ze na string nefunguje link_expander..
 	static void from_setting( string &str, const Setting &element );
 	//! This methods tries to build a new templated array 
+
+	static void from_setting( vec &vector, const Setting &element );
 
 	template<class T> static void from_setting( T* &instance, const Setting &element )
@@ -213,4 +204,6 @@
 	}
 
+	static void ui_error( string message, const Setting &element );
+
 protected:
 	//! default constructor 
@@ -223,16 +216,8 @@
 	virtual ~UI(){};
 
-
 public: 
-	static void ui_error( string message, const Setting &element )
-	{
-		stringstream error_message;
-		error_message << "UI ui_error: " << message << "! Check path """ << element.getPath() << """, source line " << element.getSourceLine() << ".";
-		it_error ( error_message.str() );
-	}
-
 	//! This methods tries to build a new instance of type T (or some of its descendant types)
 	//! according to a data stored in a DOMNode named class_name within a child nodes of the passed element.
-	//! If an ui_error occurs, it returns a NULL pointer.
+	//! If an error occurs, it returns a NULL pointer.
 
 	//! Prototype of a UI builder. Return value is by the second argument since it type checking via \c dynamic_cast.
@@ -240,5 +225,5 @@
 	{
 		T* instance;
-		from_setting<T>( reference_to_child_setting( element, index ) );
+		from_setting<T>( to_child_setting( element, index ) );
 		return instance;
 	}
@@ -247,42 +232,30 @@
 	{			
 		T* instance;
-		from_setting<T>( instance, reference_to_child_setting( element, name ) );
+		from_setting<T>( instance, to_child_setting( element, name ) );
 		return instance;
 	}
 
 	//! This methods tries to build a new double matrix 
-	template<class T> static bool get( T &instance, const Setting &element, const string &name )
-	{
-		const Setting *root = pointer_to_child_setting( element, name );
-		if( !root ) return false;				
-		from_setting( instance, *root );
-		return true;
-	}
-
-	//! This methods tries to build a new double matrix 
-	template<class T> static bool get( T &instance, const Setting &element, const int index )
-	{
-		const Setting *root = pointer_to_child_setting( element, index );
-		if( !root ) return false;				
-		from_setting( instance, *root );
-		return true;
-	}
-
-	//! This methods tries to build a new double matrix 
-	template<class T> static bool get( Array<T> &array_to_load, const Setting &element, const string &name )
-	{
-		const Setting *root = pointer_to_child_setting( element, name );
-		if( !root ) return false;				
-		from_setting( array_to_load, *root );
-		return true;
-	}
-
-	//! This methods tries to build a new double matrix 
-	template<class T> static bool get( Array<T> &array_to_load, const Setting &element, const int index )
-	{
-		const Setting *root = pointer_to_child_setting( element, index );
-		if( !root ) return false;				
-		from_setting( array_to_load, *root );
-		return true;
+	template<class T> static void get( T &instance, const Setting &element, const string &name )
+	{
+		from_setting( instance, to_child_setting( element, name ) );
+	}
+
+	//! This methods tries to build a new double matrix 
+	template<class T> static void get( T &instance, const Setting &element, const int index )
+	{
+		from_setting( instance, to_child_setting( element, index ) );
+	}
+
+	//! This methods tries to build a new double matrix 
+	template<class T> static void get( Array<T> &array_to_load, const Setting &element, const string &name )
+	{
+		from_setting( array_to_load, to_child_setting( element, name ) );
+	}
+
+	//! This methods tries to build a new double matrix 
+	template<class T> static void get( Array<T> &array_to_load, const Setting &element, const int index )
+	{
+		from_setting( array_to_load, to_child_setting( element, index ) );
 	}
 
@@ -325,4 +298,6 @@
 	static void save( const ivec &vec, Setting &element, const string &name = "" );
 	
+	static void save( const vec &vector, Setting &element, const string &name);
+
 	private: 
 	//! This methods tries to save a double vec 
@@ -385,3 +360,3 @@
 */
 
-#endif // #ifndef UIBUILD
+#endif // #ifndef USER_INFO_H
Index: /bdm/estim/arx.h
===================================================================
--- /bdm/estim/arx.h (revision 286)
+++ /bdm/estim/arx.h (revision 357)
@@ -116,5 +116,32 @@
 	}
 	//!@}
+
+	// TODO dokumentace - aktualizovat
+	/*! UI for ARX estimator
+
+	The ARX is constructed from a structure with fields:
+	\code
+	estimator = {
+		type = "ARX";
+		y = {type="rv", ...}   // description of output variables
+		rgr = {type="rv", ...} // description of regressor variables
+		constant = true;       // boolean switch if the constant term is modelled or not
+
+		//optional fields
+		dV0 = [1e-3, 1e-5, 1e-5, 1e-5]; 
+							   // default: 1e-3 for y, 1e-5 for rgr
+		nu0 = 6;               // default: rgrlen + 2
+		frg = 1.0;             // forgetting, default frg=1.0
+	};
+	\endcode
+
+	The estimator will assign names of the posterior in the form ["theta_i" and "r_i"]
+	*/
+	void from_setting( const Setting &root );
+
+	// TODO dodelat void to_setting( Setting &root ) const;
 };
+
+UIREGISTER(ARX);
 
 }
Index: /bdm/estim/libKF.cpp
===================================================================
--- /bdm/estim/libKF.cpp (revision 348)
+++ /bdm/estim/libKF.cpp (revision 357)
@@ -1,4 +1,5 @@
 
 #include "libKF.h"
+#include "..\user_info.h"
 
 namespace bdm{
@@ -250,3 +251,82 @@
 }
 
-}
+void EKFCh::from_setting( const Setting &root ) 
+{	
+	diffbifn* IM = UI::build<diffbifn>(root, "IM");
+	diffbifn* OM = UI::build<diffbifn>(root, "OM");
+	
+	//statistics
+	int dim=IM->dimension();
+	vec mu0;
+	if(root.exists("mu0"))
+		UI::get( mu0, root, "mu0");
+	else
+		mu0=zeros(dim);
+
+	mat P0;
+	if(root.exists("dP0"))
+	{
+		vec dP0;
+		UI::get( dP0, root, "dP0");
+		P0=diag(dP0);
+	}
+	else if ( root.exists( "P0" ) )
+		UI::get(P0, root, "P0");
+	else
+		P0=eye(dim);
+	
+	set_statistics(mu0,P0);
+	
+	//parameters
+	vec dQ, dR;
+	UI::get( dQ, root, "dQ");
+	UI::get( dR, root, "dR");
+	set_parameters(IM, OM, diag(dQ), diag(dR));
+
+	//connect
+	RV* drv = UI::build<RV>(root, "drv");
+	set_drv(*drv);
+	RV* rv = UI::build<RV>(root, "rv");
+	set_rv(*rv);
+	
+	string options;
+	if(root.lookupValue( "options", options ))
+		set_options(options);	
+}
+
+/*void EKFCh::to_setting( Setting &root ) const
+{	
+	Transport::to_setting( root );
+
+	Setting &kilometers_setting = root.add("kilometers", Setting::TypeInt );
+	kilometers_setting = kilometers;
+
+	UI::save( passengers, root, "passengers" );
+}*/
+
+void MultiModel::from_setting( const Setting &root ) 
+{	
+	Array<EKFCh*> A;
+	UI::get( A, root, "models");
+	
+	set_parameters(A);
+	set_drv(A(0)->_drv());
+	//set_rv(A(0)->_rv());
+
+	string options;
+	if(root.lookupValue( "options", options ))
+		set_options(options);	
+}
+
+/*void MultiModel::to_setting( Setting &root ) const
+{	
+	Transport::to_setting( root );
+
+	Setting &kilometers_setting = root.add("kilometers", Setting::TypeInt );
+	kilometers_setting = kilometers;
+
+	UI::save( passengers, root, "passengers" );
+}*/
+
+
+}
Index: /bdm/estim/arx.cpp
===================================================================
--- /bdm/estim/arx.cpp (revision 286)
+++ /bdm/estim/arx.cpp (revision 357)
@@ -1,3 +1,4 @@
 #include "arx.h"
+#include "..\user_info.h"
 
 namespace bdm {
@@ -194,3 +195,51 @@
 }
 
-}
+void ARX::from_setting( const Setting &root ) 
+{	
+	RV *yrv = UI::build<RV>(root,"y");
+	RV *rrv = UI::build<RV>(root,"rgr");
+	int ylen = yrv->_dsize();
+	int rgrlen = rrv->_dsize();
+	
+	//init
+	mat V0;
+	if( root.exists("dV0") )
+	{
+		vec dV0;
+		UI::get( dV0, root, "dV0" );
+		V0=diag ( dV0 );
+	}
+	else
+		V0=concat ( 1e-3*ones ( ylen ), 1e-5*ones ( rgrlen ) );
+	
+	double nu0;
+	if ( !root.lookupValue( "nu0", nu0 ) ) 
+		nu0 = rgrlen+ylen+2;
+
+	double frg;
+	if ( !root.lookupValue( "frg", frg ) ) 
+		frg = 1.0;
+
+	set_parameters(frg);
+	set_statistics(ylen,V0, nu0);
+	set_drv(concat(*yrv,*rrv));
+	
+	//name results (for logging)
+	set_rv(RV("{theta r }", vec_2(ylen*rgrlen, ylen*ylen)));
+	
+	delete yrv; 
+	delete rrv;
+}
+
+/*void ARX::to_setting( Setting &root ) const
+{	
+	Transport::to_setting( root );
+
+	Setting &kilometers_setting = root.add("kilometers", Setting::TypeInt );
+	kilometers_setting = kilometers;
+
+	UI::save( passengers, root, "passengers" );
+}*/
+
+
+}
Index: /bdm/estim/libKF.h
===================================================================
--- /bdm/estim/libKF.h (revision 338)
+++ /bdm/estim/libKF.h (revision 357)
@@ -258,5 +258,13 @@
 			//! Here dt = [yt;ut] of appropriate dimensions
 			void bayes ( const vec &dt );
-	};
+
+			void from_setting( const Setting &root );
+
+			// TODO dodelat void to_setting( Setting &root ) const;
+
+	};
+
+	UIREGISTER(EKFCh);
+
 
 	/*!
@@ -447,5 +455,13 @@
 				//all posterior densities are equal => return the first one
 			const enorm<chmat>& posterior() const {return est;}
-	};
+
+			void from_setting( const Setting &root );
+
+			// TODO dodelat void to_setting( Setting &root ) const;
+
+	};
+
+	UIREGISTER(MultiModel);
+
 
 
Index: /bdm/bdmroot.cpp
===================================================================
--- /bdm/bdmroot.cpp (revision 357)
+++ /bdm/bdmroot.cpp (revision 357)
@@ -0,0 +1,6 @@
+#include "bdmroot.h"
+
+//! Space of basic BDM structures
+namespace bdm
+{
+}
Index: /bdm/bdmroot.h
===================================================================
--- /bdm/bdmroot.h (revision 357)
+++ /bdm/bdmroot.h (revision 357)
@@ -0,0 +1,59 @@
+/*!
+  \file
+  \brief Bayesian Models (bm) that use Bayes rule to learn from observations
+  \author Vaclav Smidl.
+
+  -----------------------------------
+  BDM++ - C++ library for Bayesian Decision Making under Uncertainty
+
+  Using IT++ for numerical operations
+  -----------------------------------
+*/
+
+#ifndef BDMROOT_H
+#define BDMROOT_H
+
+#include <string>
+
+#include "itpp_ext.h"
+#include "libconfig/libconfig.h++"
+
+using namespace libconfig;
+using namespace itpp;
+using namespace std;
+
+namespace bdm {
+
+//! Root class of BDM objects
+class bdmroot {
+public:
+	//! make sure this is a virtual object
+	virtual ~bdmroot() 
+	{
+	}
+
+	//! This method returns a basic info about the current instance
+	virtual string to_string()
+	{
+		return "";
+	}
+
+	//! This method arrange instance properties according the data stored in the Setting structure
+	virtual void from_setting( const Setting &root )
+	{
+	}
+
+	//! This method save all the instance properties into the Setting structure 
+	virtual void to_setting( Setting &root ) const
+	{	
+	}
+
+	//! This method TODO
+	virtual void validate()
+	{
+	}
+
+};
+
+}; //namespace
+#endif // BDMROOT_H
